/* This file was generated by plugin 'Nordic Semiconductor nRF5x v.1.2.2' (BDS version 1.1.3135.0) */

#ifndef BLE_MYPROFILE_H__
#define BLE_MYPROFILE_H__

#include <stdint.h>
#include <stdbool.h>
#include "ble.h"
#include "ble_srv_common.h"
#include "app_util_bds.h"



/**@brief MyProfile event type. */
typedef enum
{ 
    BLE_MYPROFILE_MYCHARACTERISTIC_EVT_NOTIFICATION_ENABLED,  /**< MyCharacteristic value notification enabled event. */
    BLE_MYPROFILE_MYCHARACTERISTIC_EVT_NOTIFICATION_DISABLED, /**< MyCharacteristic value notification disabled event. */
    BLE_MYPROFILE_MYCHARACTERISTIC_EVT_CCCD_WRITE, /**< MyCharacteristic CCCD write event. */
    BLE_MYPROFILE_MYCHARACTERISTIC_EVT_WRITE, /**< MyCharacteristic write event. */
} ble_myprofile_evt_type_t;

// Forward declaration of the ble_myprofile_t type.
typedef struct ble_myprofile_s ble_myprofile_t;








/**@brief MyCharacteristic structure. */
typedef struct
{
    uint8_t value;
} ble_myprofile_mycharacteristic_t;

/**@brief MyProfile Service event. */
typedef struct
{
    ble_myprofile_evt_type_t evt_type;    /**< Type of event. */
    union {
        uint16_t cccd_value; /**< Holds decoded data in Notify and Indicate event handler. */
        ble_myprofile_mycharacteristic_t mycharacteristic; /**< Holds decoded data in Write event handler. */
    } params;
} ble_myprofile_evt_t;

/**@brief MyProfile Service event handler type. */
typedef void (*ble_myprofile_evt_handler_t) (ble_myprofile_t * p_myprofile, ble_myprofile_evt_t * p_evt);

/**@brief MyProfile Service init structure. This contains all options and data needed for initialization of the service */
typedef struct
{
    ble_myprofile_evt_handler_t     evt_handler; /**< Event handler to be called for handling events in the MyProfile Service. */
    ble_myprofile_mycharacteristic_t ble_myprofile_mycharacteristic_initial_value; /**< If not NULL, initial value of the MyCharacteristic characteristic. */ 
} ble_myprofile_init_t;

/**@brief MyProfile Service structure. This contains various status information for the service.*/
struct ble_myprofile_s
{
    ble_myprofile_evt_handler_t evt_handler; /**< Event handler to be called for handling events in the MyProfile Service. */
    uint16_t service_handle; /**< Handle of MyProfile Service (as provided by the BLE stack). */
    ble_gatts_char_handles_t mycharacteristic_handles; /**< Handles related to the MyCharacteristic characteristic. */
    uint16_t conn_handle; /**< Handle of the current connection (as provided by the BLE stack, is BLE_CONN_HANDLE_INVALID if not in a connection). */
};

/**@brief Function for initializing the MyProfile.
 *
 * @param[out]  p_myprofile       MyProfile Service structure. This structure will have to be supplied by
 *                          the application. It will be initialized by this function, and will later
 *                          be used to identify this particular service instance.
 * @param[in]   p_myprofile_init  Information needed to initialize the service.
 *
 * @return      NRF_SUCCESS on successful initialization of service, otherwise an error code.
 */
uint32_t ble_myprofile_init(ble_myprofile_t * p_myprofile, const ble_myprofile_init_t * p_myprofile_init);

/**@brief Function for handling the Application's BLE Stack events.*/
void ble_myprofile_on_ble_evt(ble_myprofile_t * p_myprofile, ble_evt_t * p_ble_evt);

/**@brief Function for setting the MyCharacteristic.
 *
 * @details Sets a new value of the MyCharacteristic characteristic. The new value will be sent
 *          to the client the next time the client reads the MyCharacteristic characteristic.
 *          This function is only generated if the characteristic's Read property is not 'Excluded'.
 *
 * @param[in]   p_myprofile                 MyProfile Service structure.
 * @param[in]   p_mycharacteristic  New MyCharacteristic.
 *
 * @return      NRF_SUCCESS on success, otherwise an error code.
 */
uint32_t ble_myprofile_mycharacteristic_set(ble_myprofile_t * p_myprofile, ble_myprofile_mycharacteristic_t * p_mycharacteristic);

/**@brief Function for sending the MyCharacteristic.
 *
 * @details The application calls this function after having performed a mycharacteristic.
 *          The mycharacteristic data is encoded and sent to the client.
 *          This function is only generated if the characteristic's Notify or Indicate property is not 'Excluded'.
 *
 * @param[in]   p_myprofile                    MyProfile Service structure.
 * @param[in]   p_mycharacteristic               New mycharacteristic.
 *
 * @return      NRF_SUCCESS on success, otherwise an error code.
 */
uint32_t ble_myprofile_mycharacteristic_send(ble_myprofile_t * p_myprofile, ble_myprofile_mycharacteristic_t * p_mycharacteristic);
uint32_t ble_my_service_value_update(ble_myprofile_t * p_myprofile, uint8_t data);

#endif //_BLE_MYPROFILE_H__
